c "Hurricane Escape"   = hurricane25, = checked =
      implicit real*8 (a-h,o-z)
      common /com0/ pi,zpi

      rnosu=1.
c.................................

      dist0=1000
      bear0=275
      track0=091
      speed0=11
      cpa0=150
      vship0= 7

c.................................

      write(*,*)'~~~~~~~~ Escape from hurricane (="HUR")~~~~~~~<v3>~~~'
      write(*,*)
      write(*,*)'The calculation assumes, that the hurricane moves at '
      write(*,*)'velocity V in a certain direction(track). Since that'
      write(*,*)'velocity may change, an uncertainty U=V/2 is assumed,'
      write(*,*)'so that the vector U is added at random to vector V.'
      write(*,*)'The escape-direction then is chosen such that a '
      write(*,*)'minimal distance from the hurricane is guaranteed,'
      write(*,*)'even under the uncertainty U in hurricane-velocity. -'
      write(*,*)'Three different areas relative to hurricane-center'
      write(*,*)'are discriminated: '
      write(*,*)'  INNER, EXTERNAL, and DISTANT area,'
      write(*,*)'with different escape-procedures being recommended.'
      write(*,*)'[Warning:  Not safe for navigation, use with care!]'
      write(*,*)
      write(*,*) 'if ship is NORTH of equator,  enter  "1"'
      write(*,*) 'if ship is SOUTH of equator,  enter  "2"'
      call readit(rnosu)
      nosu=rnosu+0.1
c
      call hurrica(nosu,dist0,bear0,cpa0,speed0,track0,vship0)
      write(*,*) '~~~~~~~~~~~~~~~~~~~END of Program~~~~~~~~~~~~~~~~~~~~'
      write(*,*)
      stop
      end
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      subroutine hurrica(nosu,dist0,bear0,cpa0,speed0,track0,vship0)
c "definitions:
c "pa(1) = x-value of point a (attention: +x in north-direction)
c "pa(2) = y-value of point a (attention: +y in east-direction)
c "vh(1) = x-value of vector h
c "vh(2) = y-value of vector h
c "all bearings given in degrees 0..360
c "beh0h1= Bearing of point H1 seen from H0
c "be1 be2= Bearings of Lines from H0 to circle CPA around A
      implicit real*8 (a-h,o-z)
      dimension pa(2), ph0(2),ph1(2),ph2(2),ph3(2)
      dimension icrs(800),kcrs(800)
      dimension vva(800),ivva(800)
      common /com0/ pi,zpi
      pi=3.1415926535898d0
      zpi=2.d0*pi
      qdr=zpi/360.d0
      qrd=360.d0/zpi
      n=10
      iday=0
      ihour=0
      imin=0
      isec=0
      nc=360

 1    continue
c "initialize indices"
      
      do 2 i=1,50
       write(*,*)
 2    continue
      do 3 i=1,800
      icrs(i)=0
      kcrs(i)=0
      vva(i)=0
      ivva(i)=1
 3    continue
      write(*,*)'~~~ Escape from an approaching hurricane (="HUR") ~~~'
      if(nosu.le.1) then
      write(*,*)' (Ship position is in NORTHERN hemisphere of earth)'
      else
      write(*,*)' (Ship position is in SOUTHERN hemisphere of earth)'
      endif
c     possible courses for v=18: 349 and 282 degrees; for v=15: north!

      write(*,*) '         INPUT now:'
      write(*,*)
      write(*,*) 'Distance of hurricane from ship in nautical miles =?'
      write(*,*) '        (to exit, enter 0)'
      call readit(dist0)
      if(dist0.le.0.) return
      write(*,*) 'Direction of hurricane seen from ship in degrees ='
      write(*,*) '   (relative to geographic north-direction)'
      call readit(bear0)
      write(*,*) 'Direction of advancement of hurricane in degrees =?'
      call readit(track0)
      write(*,*) 'Speed of hurricane in knots =?'
      call readit(speed0)
      write(*,*) 'Distance to be kept from center of hurricane ',
     &           'in nautical miles =?'
      call readit(cpa0)
      write(*,*) 'Maximum speed of SHIP in knots=?'
      call readit(vship0)
      vship0=dabs(vship0)
      dist0=dabs(dist0)
      bear0=dabs(bear0)
      cpa0=dabs(cpa0)
      track0=dabs(track0)
      speed0=dabs(speed0)
      do 4 ih=1,40
        write(*,*)
 4    continue
 990  continue
      dist=dist0
      bear=bear0
      cpa=cpa0
      speed=speed0
      dspeed= 0.5d0*speed
      spmax=speed+dspeed
      spmin=speed-dspeed
      if(spmin.lt.0.) spmin=0.d0
      track=track0
      vship=vship0
      if(vship.lt.1.e-19) vship=1.e-19
      
      vh=speed
      va=vship
      
c "Print INPUT-DATA ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~"
      write(*,*) '~~~ Escape from an approaching hurricane (="HUR")~~~'
      write(*,*)
      call myname(dist0,bear0,track0)
c     write(6,951) dist,bear,track,speed,dspeed,cpa,vship
      write(6,952) dist,bear,track,speed,dspeed,cpa,vship
      write(*,*)
      write(*,*) '         ==> Result:'
c      read(*,*)
      pa(1)=0.
      pa(2)=0.

c     write(*,*) '# Positions H0 and H1:'
      be=bear
      ra=dist
      call xbepo(be,ra,xx,yy)
      ph0(1)=xx
      ph0(2)=yy
c     "Shift origin to H0
      pa(1)=pa(1)-ph0(1)
      pa(2)=pa(2)-ph0(2)
      ph0(1)=0.d0
      ph0(2)=0.d0
c
      be=track
      ra=speed
      call xbepo(be,ra,xx,yy)
c     write(*,*) '# xx,yy',xx,yy
      ph1(1)=xx+ph0(1)
      ph1(2)=yy+ph0(2)
c      write(*,*) '# h0:',ph0(1),ph0(2)
c      write(*,*) '# h1:',ph1(1),ph1(2)
c     write(*,*)
c     write(*,*) '# Tangents from H0 to circle around A:'
      xxa=ph0(1)
      yya=ph0(2)
      xxb=pa(1)
      yyb=pa(2)
      rb=cpa
      call tangt(xxa,yya,xxb,yyb,rb,xt1,yt1,xt2,yt2,bec,be1,be2)
c     write(*,*) '# bearings be1,bec,be2=',be1,bec,be2
      xx=ph1(1)-ph0(1)
      yy=ph1(2)-ph0(2)
      call xpobe(xx,yy,beh0h1,rah1)
c "beh0h1= Bearing of point H1 seen from H0
c "be1 be2= Bearings of Lines from H0 to circle CPA around A
c "bec=bearing from H0 to A
c     write(*,*) '# beh0h1,rah1:',beh0h1,rah1
c     write(*,*) '# bearings be1,bec,be2=',be1,bec,be2

c "Angles between beh0h1 and be1 or be2 , and normals to be1,be2
      w1=be1-beh0h1
      w2=be2-beh0h1
      ben1=be1-90.  +180.5
      ben2=be2+90.  +180.5
      call norma(ben1)
      call norma(ben2)
      kben1=ben1
      kben2=ben2
c "Normals rn1,rn2 from H1 to Lines be1 and be2
      rn1=dabs(speed*sin(qdr*w1))
      rn2=dabs(speed*sin(qdr*w2))
c     write(*,*) '# angles w1,w2',w1,w2
c "Check whether H1 is inside (iwx=0) critical triangel be1,be2 or not"
      call wcheck(be1,be2,beh0h1,iwx)
      kdir=iwx
      hh=bear+180.d0
      call norma(hh)
      kanti=hh+0.5
c "Check, whether H1 is in critical area (karea>0) or not (karea=0)
      xx=ph1(1)
      yy=ph1(2)
      call cocheck(xx,yy,ph0,be1,bec,be2,dspeed,karea)

c "Points k through which the new Limit-Lines are going
      if(iwx.eq.0) then
      rn1k=dspeed+rn1
      rn2k=dspeed+rn2
      endif
      if(iwx.eq.-1) then
      rn1k=dspeed-rn1
      rn2k=dspeed+rn2
      endif
      if(iwx.eq. 1) then
      rn1k=dspeed+rn1
      rn2k=dspeed-rn2
      endif

c "check for allowed area: fusspunkte kreis um H1 pruefen
      rewind 9
c      write(*,*) '# H0,H1', ph0(1),ph0(2),ph1(1),ph1(2)
c      write(*,*) '# beh01',beh01
c      write(*,*) '# be1,be2,bec', be1,be2,bec
      do 790 i=0,360
        im=i-1
        xx=vship*dcos(i*qdr)+ph1(1)
        yy=vship*dsin(i*qdr)+ph1(2)
        call cocheck(xx,yy,ph0,be1,bec,be2,dspeed,ibax )
        j=i+180
        if(j.gt.360) j=j-360
        if(j.lt.1) j=j+360
        icrs(j)=ibax
 790  continue
      call  limits(nc,icrs,kcrs,numc)
      if(numc.ne.0) then
c       write(*,*)'>kcrs=',(kcrs(i),i=1,numc)
      endif

c "Produce output COMMENTS .......................
c      write(*,*) 'Program HURRIC_A:'
      if(kdir.eq.2) then
        write(*,*)'    Hurricane moves away from ship.'
        write(*,*)'[A] Escape against hurricane-bearing, course=', kanti
      endif

c     write(*,*) '# numc,kdir,karea=',numc,kdir,karea
      if(numc.gt.0) then
       write(*,*) '    Possible courses are [clockwise] between:'
      else
       if(karea.eq.0) then
        write(*,*)'[A] All courses possible'
       else
        write(*,*)'    Escape not guaranteed!'
       endif
      endif
      if(numc.ge.2) then
        write(6,930) kcrs(1),kcrs(2)
      endif
      if(numc.eq.4) then
        write(6,930) kcrs(3),kcrs(4)
        write(*,*)'    (Two directions for escape possible)'
      endif
      
      irang=2
      if(numc.eq.0 .and. karea.ne.0) irang=1
      if(dist0.lt.cpa0)              irang=0

c "sicherste kurse ausgeben
      if(numc.eq.4) then
       if(dabs(rn1k).le.dabs(rn2k)) then
         write(6,931) kben1
         if(karea.ne.0) write(6,932) dabs(rn1k)
         write(6,931) kben2
         if(karea.ne.0) write(6,932) dabs(rn2k)
       else
         write(6,931) kben2
         if(karea.ne.0) write(6,932) dabs(rn2k)
         write(6,931) kben1
         if(karea.ne.0) write(6,932) dabs(rn1k)
       endif
      endif
      if(numc.eq.2) then
        if(dabs(rn1k).le.dabs(rn2k)) then
         write(6,931) kben1
         if(karea.ne.0) write(6,932) dabs(rn1k)
        else
         write(6,931) kben2
         if(karea.ne.0) write(6,932) dabs(rn2k)
        endif
      endif
      if(karea.eq.0) then
        write(*,*) '    (Remaining on place would also be possible)'
      endif

c "Calculate possible Maximum of CPA and associated course"
 801  continue
      beaa=bear+180.
      call norma(beaa)
      alfa=beaa - beh0h1
      call normb(alfa)
      if(vship.gt.speed) then
        icpa=dist +0.5
        write(*,*)'    CPA irrelevant, since ship faster than hurricane'
        ibecpa=beaa
        cpa=dist0
        goto 802
      endif
      beta=dasin(vship/speed)*qrd
      call normb(beta)
      asum1=dabs(alfa+beta)
      asum2=dabs(alfa-beta)
      asum=asum1
      if(asum2.gt.asum1) asum=asum2
      gamma=90.-asum
c      write(*,*) '# alfa,beta,asum1,asum2',alfa,beta,asum1,asum2
      if(gamma.le.0.) then
        icpa=dist +0.5
        write(*,*)'    Maximum of CPA =',icpa,' [nm] already achieved!'
        ibecpa=beaa
        cpa=dist0
        goto 802
      endif
      call norma(gamma)
      cpa=    dabs(dist*dcos(gamma*qdr))
      cpadist=dabs(dist*dsin(gamma*qdr))
      rspeed=speed*dcos(beta*qdr)
      tcpa=cpadist/rspeed
      time=tcpa
      call timday(time,iday,ihour,imin,isec)
      if(alfa.ge.0.) then
        becpa=beaa+gamma
      else
        becpa=beaa-gamma
      endif
      call norma(becpa)
c      write(*,*) '# becpa,gamma,asum,beaa',becpa,gamma,asum,beaa
      ibecpa=becpa+0.5
 802  continue
      if(cpa.lt.dist0) then
c      write(6,955) cpa,iday,ihour,imin,isec,ibecpa
       write(6,956) cpa,iday,ihour,imin,isec, becpa
      else
       write(*,*) '    (Suggested course would be',ibecpa,' degrees)'
      endif
      write(*,*) ' '
      if(vship.lt. speed/2.) then
      write(*,*)'    (Slow ships may take direction',
     &          ' orthogonal to HUR-track)'
      endif
cc      write(*,*) '~~~ alfa,nosu=',alfa,nosu
      if(nosu.le.1) then
        if(alfa.gt.0. .and. abs(alfa).lt.90.)
     &  write(*,*)'    Ship is in DANGEROUS QUARTER of hurricane'
      else
        if(alfa.lt.0. .and. abs(alfa).lt.90.)
     &  write(*,*)'    Ship is in DANGEROUS QUARTER of hurricane'
      endif
      if(irang.eq.0) write(6,960)
      if(irang.eq.1) write(6,961)
      if(irang.eq.2) write(6,962)
      if(irang.gt.2) write(*,*) '# irang not set',irang

 999  continue
      write(*,*)
      write(*,*) '     <..hit RETURN to restart>'
      read(*,*)
      if(0.eq.0) goto 1
      return
 901  format(1x,2i5,' beh0h3=',f6.1,' -  crsa=',f6.1,2e12.4)
 902  format(1x,2i5,' beh0h3=',f6.1,' +  crsa=',f6.1,2e12.4)
 903  format(1x,2i5)
 921  format(1x,3i5)
 930  format(1x,'   ',i5,'  and',i5,' degrees')
 931  format(1x,'[A] Recommended escape course =',i4,' degrees')
 932  format(1x,'    and minimal speed of ship=',f4.1,' kts')
 933  format(1x,'    (the limit',f5.0,
     & ' connects the two allowed regions)')
 934  format(1x,'    and minimal speed of ship=',f4.1,' kts or ZERO.')
 951  format(1x,'Distance of hurricane from ship[nm]=',f6.0,
     & /' Direction of hurricane seen from ship[degrees]=',f5.0,
     & /' Direction of motion of hurricane[degrees]=',f5.0,
     & /' Speed of advancement of hurricane[kts]=',f5.1,' (+-',f5.1,')'
     & /' Radius of critical area around hurricane-center[nm]=',f5.0,
     & /' Maximal speed of ship[kts]=',f5.1)
 952  format(1x,'Distance of HUR [nm]=',f5.0,
     &  '  Direction of HUR seen from ship [deg]=',f5.0,
     & /' Track-direction of HUR [deg]=',f5.0,
     &  '  Advancement-speed of HUR [kt]=',f5.1,'+-',f4.1,
     & /' Radius of HUR to be avoided [nm]=',f5.0,
     &  '  Max-speed of SHIP[kts]=',f5.1)
 955  format(1x,'    Maximally possible CPA =',f6.1,' nm',
     & /'     with time-to-go=',i3,' d',i3,' h',i3,' m',i3,' s'
     & /' [B] For probable CPA-max, take the course =',i4,' degrees!')
 956  format(1x,'    Maximally possible CPA =',f6.1,' nm',
     & /'     with time-to-go=',i3,' d',i3,' h',i3,' m',i3,' s'
     & /' [B] For probable CPA-max, take the course =',f6.1,' degrees!')
 960  format(1x,'===> Ship now within INTERNAL AREA of IMPACT !!! ',
     &  'of hurricane,',/'     keep wind from starbord and hope!')
 961  format(1x,'===> Ship already in EXTERNAL AREA of IMPACT ! ',
     &  'of hurricane, escape via [B]')
 962  format(1x,'===> Ship still DISTANT to hurricane, escape via [A]')
      end
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      subroutine myname(day,month,year)
      implicit real*8(a-h,o-z)
      real*8 month
      character xcar
      md=day
      mm=month
      my=year
      if(md.eq.20.and.mm.eq.4.and.my.eq.1944) then
      write(*,*) '                     COPYRIGHT :'
      write(*,*) '          <author: Heiner Mueller-Krumbhaar>'
      write(*,*) '     <address: Poststr.5, D-40789 Monheim, Germany>'
      write(*,*)
      write(*,*) '         ------  hit [ENTER] to continue :'
      xcar='-'
      read(5,'(a)') xcar
      endif
      return
      end
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      subroutine readit(xxx)
      implicit real*8 (a-h,o-z)
      character*8 aaa,bbb
      bbb=' '
      aaa='abcdefgh'
      write(6,901) xxx
      read(5,'(a)') aaa
      write(*,*) aaa
      if(aaa.eq.bbb) return
      read(aaa,*) xxx
      if(xxx.gt.  999999.) xxx= 999999.
      if(xxx.lt. -999999.) xxx=-999999.
      return
 901  format('        [ Default: ',f10.1,' ].    Input=')
      end
ccccccccccccccccccccccccccccccccc
      subroutine xbepo(be,ra,xx,yy)
      implicit real*8 (a-h,o-z)
c "convert bearing and radius to position
c "warning: xx goes vertical, yy goes horizontal!
      common /com0/ pi,zpi
      call norma(be)
      ang=be* zpi/360.
cc     write(*,*) '#xbepo-be,ang',be,ang
      xx=ra*dcos(ang)
      yy=ra*dsin(ang)
cc     write(*,*) '#xbepo  be,ra,xx,yy'
c      write(*,*)   be,ra,xx,yy
      return
      end
ccccccccccccccccccccccccccccccccc
      subroutine xpobe(xx,yy,be,ra)
      implicit real*8 (a-h,o-z)
c "convert position to bearing and radius
c "warning: xx goes vertical, yy goes horizontal!
      common /com0/ pi,zpi
      ra=dsqrt(xx*xx+yy*yy+1.e-19)
      ang0=dasin(abs(yy)/ra)
      if(xx.ge.0.0 .and.  yy.ge.0.0) ang= ang0
      if(xx.ge.0.0 .and.  yy.le.0.0) ang=-ang0+zpi
      if(xx.le.0.0 .and.  yy.ge.0.0) ang=-ang0+pi
      if(xx.le.0.0 .and.  yy.le.0.0) ang= ang0+pi
      be=ang*360./zpi
      call norma(be)
cc     write(*,*) '#xpobe xx,yy,be,ra'
c      write(*,*)    xx,yy,be,ra
      return
      end
ccccccccccccccccccccccccccccccccc
      subroutine tangt(xxa,yya,xxb,yyb,rb,xt1,yt1,xt2,yt2,bec,be1,be2)
      implicit real*8 (a-h,o-z)
c "calculate tangents from xxa to circle with radius rb around xxb
c "tangential points are xt1,xt2 and bearings be1,be2
c "warning: xx goes vertical, yy goes horizontal!
      common /com0/ pi,zpi
c normalize
cc     write(*,*) '#xxa,yya,xxb,yyb,rb '
c      write(*,*)   xxa,yya,xxb,yyb,rb
      xa=0.
      ya=0.
      rb=abs(rb)
      xb=xxb-xxa
      yb=yyb-yya
      call xpobe(xb,yb,bec,dab)
      ang=dasin(rb/dab)
      dbec=ang*360./zpi
      be1= bec-dbec
      be2= bec+dbec
      call norma(be1)
      call norma(be2)
      dist=dsqrt(dab*dab-rb*rb)
      call xbepo(be1,dist,xt1,yt1)
      call xbepo(be2,dist,xt2,yt2)
      xt1=xt1+xxa
      xt2=xt2+xxa
      yt1=yt1+yya
      yt2=yt2+yya
c     write(*,*) '#tangt bec,dab,dist=', bec,dab,dist
      return
      end

ccccccccccccccccccccccccccccccccc
      subroutine slop(xx,yy,be,ra)
      implicit real*8 (a-h,o-z)
c "convert position to bearing and radius
c "warning: xx goes vertical, yy goes horizontal!
      common /com0/ pi,zpi
      ra=dsqrt(xx*xx+yy*yy+1.e-19)
      ang0=dasin(abs(yy)/ra)
      if(xx.ge.0.0 .and.  yy.ge.0.0) ang= ang0
      if(xx.ge.0.0 .and.  yy.le.0.0) ang=-ang0+zpi
      if(xx.le.0.0 .and.  yy.ge.0.0) ang=-ang0+pi
      if(xx.le.0.0 .and.  yy.le.0.0) ang= ang0+pi
      be=ang*360./zpi
      if(be.ge.360.) be=be-360.
      if(be.lt.0.) be=be+360.
cc     write(*,*) '#xpobe xx,yy,be,ra'
c      write(*,*)    xx,yy,be,ra
      return
      end
ccccccccccccccccccccccccccccccccccc
      subroutine norma(bearing)
c "normalize angles between 0 and 360."
      implicit real*8 (a-h,o-z)
  1   continue
      ind=0
      if(bearing.lt.0.0) then
        bearing=bearing+360.
        ind=1
      endif
      if(bearing.ge.360.0) then
        bearing=bearing-360.0
        ind=1
      endif
      if(ind.ne.0) goto 1
      return
      end
ccccccccccccccccccccccccccccccccccc
      subroutine normb(bearing)
c "normalize angles between -180 and +180"
      implicit real*8 (a-h,o-z)
      call norma(bearing)
      if(bearing.gt.180.d0) bearing=bearing-360.
      return
      end
cccccccccccccccccccccccccccccccccccc

      subroutine sumrule(track,speed,beh0h3,rah3,crsa,raa,chk)
      implicit real*8 (a-h,o-z)
      common /com0/ pi,zpi
      qq=zpi/360.
      qtrack=track*qq
      qbeh0h3=beh0h3*qq
      qcrsa=crsa*qq
      xabs=speed*dcos(qtrack)
      yabs=speed*dsin(qtrack)
      xrel=rah3*dcos(qbeh0h3)
      yrel=rah3*dsin(qbeh0h3)
      xa=raa*dcos(qcrsa)
      ya=raa*dsin(qcrsa)
      dx=xabs-(xa+xrel)
      dy=yabs-(ya+yrel)
      chk=dsqrt(dx*dx+dy*dy)
      if(chk.gt.1.e-3) then
       write(*,*) 'ERROR in sumrule:'
c     write(*,*) '#chk: track,speed,beh0h3,rah3,crsa,raa,chk '
c     write(*,*)        track,speed,beh0h3,rah3,crsa,raa,chk
       stop
      endif
      return
      end
ccccccccccccccccccccccccccccccc
      subroutine allow(w1,w2,ww,iall)
c "check, if angle ww is between w1 and w2: iall=1; else iall=0
      implicit real*8 (a-h,o-z)
      iall=0
      w1x=w1-w1
      w2x=w2-w1
      wwx=ww-w1
      call norma(w1x)
      call norma(w2x)
      call norma(wwx)
      if(wwx.ge.w1x .and. wwx.le.w2x) iall=1
      return
      end
ccccccccccccccccccccccccccccccc
      subroutine wchex(w1,w2,ww,iwx)
c "check, if angle ww is between w1 and w2: iwx=1;
c" if outside: iwx=0; if ww in opposite direction: iwx=2
c "(note: use always positive angle-differences for checking!
      implicit real*8 (a-h,o-z)
      iwx=0
      call norma(w1)
      call norma(w2)
      call norma(ww)
      w0=0.5d0*(w1+w2)
      wy=w0-90.d0
      call norma(w0)
      call norma(wy)
c
      w1x=w1-w1
      w2x=w2-w1
      wwx=ww-w1
      wyx=wy-w1
c
      if(wwx.lt.360.d0) iwx=-1
      if(wwx.gt.w2x )   iwx= 1
c
      dww0=ww-wy
      call norma(dww0)
      if(dww0.gt.180.) iwx=2
c
c     write(*,*) '# wcheck >>>>>>'
c      write(*,*) '# w1,ww,w2', w1,ww,w2
c      write(*,*) '# w1x,wwx,w2x',w1x,wwx,w2x
c     write(*,*) '# wcheck iwx=',iwx,' <<<<<<'
      return
      end
ccccccccccccccccccccccccccccccc
      subroutine wcheck(w1,w2,ww,iwx)
c "check, if angle ww is between w1 and w2: iwx=0;
c "smaller than w1: iwx=-1; bigger than w2: iwx=1;
c "in opposite direction: iwx=2
c "(note: use always positive angle-differences for checking!
      implicit real*8 (a-h,o-z)
      iwx=0
      call norma(w1)
      call norma(w2)
      call norma(ww)
      w0 =0.5d0*(w1+w2)+180.
c
      w1x=w1-w1
      w2x=w2-w1
      wwx=ww-w1
      w0x=w0-w1
c
      w1y=w1x-90.d0
      w2y=w2x+90.d0
c
      call norma(w1x)
      call norma(w2x)
      call norma(wwx)
      call norma(w0x)
      call norma(w1y)
      call norma(w2y)
c
      if(wwx.ge.w1x .and. wwx.le.w2x)    iwx= 0
      if(wwx.ge.w2x. and. wwx.le.w2y)    iwx= 1
      if(wwx.ge.w2y .and. wwx.le.w1y)    iwx=2
      if(wwx.le.360.d0 .and. wwx.ge.w1y) iwx=-1

c
c     write(*,*) '# wcheck >>>>>>'
c     write(*,*) '# w1,ww,w2', w1,ww,w2
c     write(*,*) '# wwx,w1x,w2x,w2y,w1y',wwx,w1x,w2x,w2y,w1y
c     write(*,*) '# wcheck iwx=',iwx,' <<<<<<'
      return
      end
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      subroutine timday(time,iday,ihour,imin,isec)
      implicit real*8(a-h,o-z)
c "time given in HOURS, return time in DD,HH,MM,SS
c "itime=time given in seconds
      itime0=time*3600.d0+0.5d0
      itime=itime0
c days
      iz=24*3600
      inew=int(itime/dfloat(iz))
      itime=itime-inew*iz
      iday=inew
c hours
      iz=3600
      inew=int(itime/dfloat(iz))
      itime=itime-inew*iz
      ihour=inew
c minutes
      iz=60
      inew=int(itime/dfloat(iz))
      itime=itime-inew*iz
      imin=inew
c seconds
      isec=itime
c check
      itime1=((iday*24+ihour)*60+imin)*60+isec
c      write(*,*) '# time,itime0,itime1',time,itime0,itime1
      return
      end
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      subroutine rotw1(w0,w1,w2,zw1,zw2)
c "Rotate directions w1,w2 so that w0 becomes direction zero,
c "new directions are zw1,zw2
      implicit real*8(a-h,o-z)
      call norma(w0)
      call norma(w1)
      call norma(w2)
      zw1=w1-w0
      zw2=w2-w0
      call norma(zw1)
      call norma(zw2)
      return
      end
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      subroutine rotw2(w0,w1,w2,zw1,zw2)
c "BACK-Rotate directions w1,w2 so that w0 becomes direction zero,
c "new directions are zw1,zw2
      implicit real*8(a-h,o-z)
      call norma(w0)
      call norma(w1)
      call norma(w2)
      zw1=w1+w0
      zw2=w2+w0
      call norma(zw1)
      call norma(zw2)
      return
      end
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      subroutine rotx1(w0,x0,y0,xx,yy,zxx,zyy)
c "Rotate point xx,yy around x0,y0 so that w0 becomes direction zero,
c "new point is zxx,zyy.
c "ATTENTION: x-axis to NORTH, y-axis to EAST
      implicit real*8(a-h,o-z)
      qdr=2.d0*3.14159265358979d0/360.d0
      qrd=1.d0/qdr
      call norma(w0)
      ang=w0*qdr
      cc=dcos(ang)
      ss=dsin(ang)
      x1=xx-x0
      y1=yy-y0
      zxx=   cc*x1 + ss*y1
      zyy= - ss*x1 + cc*y1
      zxx=zxx+x0
      zyy=zyy+y0
      return
      end
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      subroutine rotx2(w0,x0,y0,xx,yy,zxx,zyy)
c "BACK-Rot point xx,yy around x0,y0 from direction zero to  w0,
c "new point is zxx,zyy
c "ATTENTION: x-axis to NORTH, y-axis to EAST
      implicit real*8(a-h,o-z)
      qdr=2.d0*3.14159265358979d0/360.d0
      qrd=1.d0/qdr
      call norma(w0)
      ang=w0*qdr
      cc=dcos(ang)
      ss=dsin(ang)
      x1=xx-x0
      y1=yy-y0
      zxx=   cc*x1 - ss*y1
      zyy=   ss*x1 + cc*y1
      zxx=zxx+x0
      zyy=zyy+y0
      return
      end
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      subroutine cocheck(xx,yy,ph0,be1,bec,be2,dspeed,ibase)
      implicit real*8 (a-h,o-z)
      dimension ph0(2),ph1(2)
c "check, whether base-point xx,yy of possible vector vA
c "is in the forbidden region between bec1,bec2 and the circle
c "around h0. If NOT allowed: ibase > 0   ;    allowed: ibase=0
c
      ibase=0
c "STEP1: Rotate so that be1 is x-axis, be1 becomes zbe1 etc."
c rotate point xxyy to new position  zxx,zzy
      w0=be1
      x0=ph0(1)
      y0=ph0(2)
      call rotx1(w0,x0,y0,xx,yy,zxx,zyy)
c      write(*,*) '# rot-1'
c      write(*,*) '# xx,yy,zxx,zyy',xx,yy,zxx,zyy
c critical line L1 now is y=- dspeed= const
      yc=-dspeed
c      write(*,*) '# zyy,yc,zxx',zyy,yc,zxx
      if(zyy.ge.yc .and. zyy.le.0.  .and. zxx.ge.0.) ibase=1

c "STEP2: Rotate so that be2 is x-axis, be2 becomes zbe2 etc."
c rotate point xxyy to new position  zxx,zzy
      w0=be2
      x0=ph0(1)
      y0=ph0(2)
      call rotx1(w0,x0,y0,xx,yy,zxx,zyy)
c      write(*,*) '# rot-2'
c      write(*,*) '# xx,yy,zxx,zyy',xx,yy,zxx,zyy
c critical line L2 now is y=- dspeed= const
      yc= dspeed
c      write(*,*) '# zyy,yc,zxx',zyy,yc,zxx
      if(zyy.le.yc .and. zyy.ge.0.  .and. zxx.ge.0.) ibase=ibase+2
c
c "STEP3: Wedge between be1 and be2
c define direction of point xx,yy relative to H0
      xh=xx-ph0(1)
      yh=yy-ph0(2)
      call xpobe(xh,yh,bexy,rah)
c check whether direction bexy is between be1,be2, then iwx=0
      call wcheck(be1,be2,bexy,iwx)
      if(iwx.eq.0) ibase=ibase+4

c "STEP4: Rotate so that bec is x-axis,  etc."
c "first, rotate directions be1,be2
c      write(*,*) '*** bec',bec
      x0=ph0(1)
      y0=ph0(2)

      w0=bec
      w1=be1
      w2=be2
      call rotw1(w0,w1,w2,zw1,zw2)
      zbe1   =zw1
      zbec= 0.0
      zbe2   =zw2
c rotate point xxyy to new position  zxx,zzy
      w0=bec
      x0=ph0(1)
      y0=ph0(2)
      call rotx1(w0,x0,y0,xx,yy,zxx,zyy)
c      write(*,*) '# rot-4'
c      write(*,*) '#be1,be2,zbe1,zbe2',be1,be2,zbe1,zbe2
c      write(*,*) '# xx,yy,zxx,zyy',xx,yy,zxx,zyy
c define normals to zbe1 and zbe2 as critical lines
      zbe1n=zbe1-90.d0
      zbe2n=zbe2+90.d0
      call norma(zbe1n)
      call norma(zbe2n)
c define direction of point xx,yy relative to H0
      zxh=zxx-ph0(1)
      zyh=zyy-ph0(2)
      call xpobe(zxh,zyh,zbexy,zra)
c check whether direction zbe is between zbe1n,zbe2n, then iwx=0
c     (note, that zbe2n is first, then comes zbe1n, in parameterlist)
      call wcheck(zbe2n,zbe1n,zbexy,iwx)
c      write(*,*)'# zbe1n,zbe2n,zbexy,zra,iwx',zbe1n,zbe2n,zbexy,zra,iwx
      if(iwx.eq.0 .and. zra.le.dspeed) ibase=ibase+8
c
      return
      end
cccccccccccccccccccccccccccccccccccccccccccccccccccccc
      subroutine limits(nc,icrs,kcrs,numc)
c determine the limiting courses, cyclic in icrs(0..360)
c ifeld(i) contains only ALLOWED courses!
      implicit real*8(a-h,o-z)
      dimension ifeld(360),kfeld(360),icrs(nc),kcrs(nc)

      do 1 i=1,360
       if(icrs(i).ne.0) icrs(i)=1
       ifeld(i)=0
       kfeld(i)=0
 1    continue

      numc=0
      kcomp=icrs(360)
      do 10 i=1,360
        im=i-1
        if(im.lt.1) im=im+360
        icomp=icrs(i)
        if(icomp.ne.kcomp) then
         if(icomp.eq.0) then
          numc=numc+1
          ifeld(numc)=i
          kfeld(numc)= 1
         endif
         if(icomp.eq.1) then
          numc=numc+1
          ifeld(numc)=im
          kfeld(numc)= -1
         endif
        endif
        kcomp=icomp
 10   continue
      do 20 i=1,numc
c      write(*,*) '# i,ifeld,kfeld',i,ifeld(i),kfeld(i)
  20  continue
c
      if(numc.eq.0) goto 999
      do 101 i=1,numc
      if(kfeld(i).eq.1) goto 102
  101 continue
      write(*,*) '# ???????? error kfeld ????????'
      goto 999
  102 continue
      j=i
      do 103 i=1,numc
         kcrs(i)=ifeld(j)
         j=j+1
         if(j.gt.numc) j=j-numc
  103 continue
      do 104 i=1,numc
c      write(*,*) '# i,ifeld,kfeld,kcrs',i,ifeld(i),kfeld(i),kcrs(i)
  104 continue
      
 999  continue
c      write(*,*) '# numc=',numc
      return
      end
